"use_strict";
m.route.prefix("#");

function sleep (time) {
  return new Promise((resolve) => setTimeout(resolve, time));
}

const splash = {
  oncreate: () => {
    sleep(3000).then(() => {
      m.route.set("intro")
    });
  },
  view: () => m("main", [
    m("header","adbroot!"),
    m("img",{src:"splash.png"})
    ])
};

const intro = {
  oncreate: () => {
    document.querySelector("a").focus();
  },
  view: () => 
    m("main", [
      m("main","Hi! This small app will give you adb-root permissions on your Nokia 8110 --> Select/Enter will toggle root-permissions on/off. (toggling will disrupt existing adb-connections!) Have Fun! speeduploop"),
      m("h3", m("a", { href: "#mview" }, "Enter!"))
    ])
};

let running=false;

const check_insecure = '[ -e /sbin/adbd ] && [ "$(md5sum /sbin/adbd | cut -d\' \' -f1)" == "c3b682720bc74eb72d5002200f9db9e7" ]';
const check_secure = '[ -e /sbin/adbd ] && [ "$(md5sum /sbin/adbd | cut -d\' \' -f1)" != "c3b682720bc74eb72d5002200f9db9e7" ]';

const mount_rw = 'mount -o remount,rw / && sleep 0.25';
const mount_ro = 'mount -o remount,ro / && sleep 0.25';
const adapt_permissions = 'chown root:root /sbin/adbd && chmod 750 /sbin/adbd';
const unzip_adbd = 'mv /sbin/adbd /sbin/adbd_bak && busybox unzip -p /data/local/webapps/adbroot.speeduploop.de/application.zip native/adbd > /sbin/adbd';
const reset_adbd = '[ -e /sbin/adbd_bak ] && mv -f /sbin/adbd_bak /sbin/adbd';

const cmd = check_secure + ' && stop adbd && ' + mount_rw + ' && ' + unzip_adbd + ' && ' + adapt_permissions + ' && ' + mount_ro + ' && start adbd';
const kill = check_insecure + ' && stop adbd &&' + mount_rw + ' && ' + reset_adbd + ' && ' + mount_ro + ' && start adbd ';

const mview = {
  oncreate: () => {
    document.querySelector("button").focus();
  },
  view: () =>
    m("main", [
      m("h1", "adbroot"),
      m("h3", "by speeduploop"),
      m("hr"),
      m("button",
        {
          onclick: () => {
            if(!running) {
              navigator.engmodeExtension.startUniversalCommand(cmd, true);
              running = true;
            } else {
              navigator.engmodeExtension.startUniversalCommand(kill, true);
              running = false;
            }
          }
        },
      (running == true ? "disable" : "enable") + " root"),
      m("h3", "<<< root " + ( running ? "enabled" : "disabled" ) + " >>>")
    ])
};

m.route(document.body, "splash", {
  splash: splash,
  intro: intro,
  mview: mview
});
